#include <stdio.h>
#include <stdlib.h>

#define MAXR 1048576

typedef struct Record TRecord;
struct Record {
       int start, len;
};

typedef struct Moment TMoment;
struct Moment {
       int time, val;
};

int n, r, ans;
TRecord *rs;
TMoment *ms;

void init(void);
void readf(void);
void solve(void);
void writef(void);

int main(void) {
    init();
    readf();
    solve();
    writef();
    
    return 0;
}

void init(void) {
     rs = (TRecord*)malloc(sizeof(TRecord) * MAXR);
     ms = (TMoment*)malloc(sizeof(TMoment) * 2 * MAXR);
}

void readf(void) {
     scanf("%d", &n);
     for (r = 0; scanf("%d%d", &rs[r].start, &rs[r].len) == 2; ++r)
         ;
}

void solve(void) {
     int i, lout, cc, m;

     void sorta(TMoment a[], int n);

     for (i = 0; i < r; i++) {
         ms[2*i].time = rs[i].start;
         ms[2*i].val = 1;
         ms[2*i+1].time = rs[i].start + rs[i].len;
         ms[2*i+1].val = -1;
     }
     m = 2 * r;

     sorta(ms, m);

     for (i = cc = 0, lout = -1; i < m; ++i) {
         if (ms[i].val == 1) {
            if (ms[i].time == lout && cc >= n)
               ++ans;
            lout = -1;
         }
         if (ms[i].val == -1)
            lout = ms[i].time;
         cc += ms[i].val;
     }
}

void writef(void) {
     printf("%d\n", ans);
}

void sorta(TMoment a[], int n) {
     int i, j, g, s;
     TMoment t;

     g = n;
     do {
        s = 0;
        g = (int)(g / 1.3);
        if (g < 1)
           g = 1;
        else if (g == 9 || g == 10)
             g = 11;
        for (j = g; j < n; ++j) {
            i = j - g;
            if (a[i].time > a[j].time || a[i].time == a[j].time && a[i].val > a[j].val) {
               s = 1;
               t = a[i];
               a[i] = a[j];
               a[j] = t;
            }
        }
     }
     while (g > 1 || s != 0);
}

