/* INCLUDES *****************************************************************/
   #include <iostream>
   //#include <cstdlib>

   #include <string>
   #include <vector>

   using namespace std;

/* CONSTANTS ****************************************************************/
   int const MAX = 202;
   //int const MAXB = 200;
   int const MAXALL = 100000;

/* CLASSES ******************************************************************/
/* GLOBALS ******************************************************************/

   int n;

   bool friends[MAX][MAX];

   vector<vector<int> > gs;

   //bool used[MAX];
   int hated[MAX];

   int left;

   int c_best_path;
   int best_path[MAX];

   int c_path;
   int path[MAX];

   int maxall;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
/*   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      cin >> n;
      for (int i = 2; i <= n; ++i)
      {
         string s;
         cin >> s;
         for (int j = 1; j < i; ++j)
            if (s[j - 1] == '1')
               friends[i][j] = friends[j][i] = true;
      }
   }
/****************************************************************************/
/****************************************************************************/
   void rec(int p)
   {
      ++maxall;

      path[c_path] = p;
      ++c_path;

      for (int i = p + 1; i <= n; ++i)
         if (!friends[p][i])
            ++hated[i];

      //int b = 0;
      for (int i = p + 1; /*(b < MAXB) && */(i <= n) && (left + c_path > c_best_path) && (maxall < MAXALL); ++i)
         if (hated[i] == 0)
         {
            //++b;
            rec(i);
         }

      for (int i = p + 1; i <= n; ++i)
         if (!friends[p][i])
            --hated[i];

      if (c_path > c_best_path)
      {
         c_best_path = c_path;
         for (int i = 0; i < c_best_path; ++i)
            best_path[i] = path[i];
      }

      --c_path;
   }
/****************************************************************************/
   void run()
   {
      /*for (int i = 1; i <= n; ++i)
      {
         for (int j = 1; j <= n; ++j)
            cout << friends[i][j] << ' ';
         cout << endl;
      }
      /**/
      left = n;
      for (int i = 1; i <= n; ++i)
         if (hated[i] == 0)
         {
            c_best_path = 0;
            c_path = 0;
            //used[i] = true;

            maxall = 0;

            rec(i);

            left -= c_best_path;

            gs.push_back(vector<int>(best_path, best_path + c_best_path));

            for (int i = 0; i < c_best_path; ++i)
               ++hated[best_path[i]];
         }

      cout << gs.size() << endl;
      for (int i = 0; i < gs.size(); ++i)
      {
         cout << gs[i].size() << endl;
         for (int j = 0; j < gs[i].size() - 1; ++j)
            cout << gs[i][j] << ' ';
         cout << gs[i][gs[i].size() - 1] << endl;
      }
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      //done();

      return 0;
   }
/****************************************************************************/

