#include <stdio.h>
#include <stdlib.h>

#define MAXN            1000010

int s[MAXN];
int e[MAXN];
int count;
int n;

int int_cmp(const void *a, const void *b) {
    return ( (*((int*)a)) - (*((int*)b)) );
}

void read_data() {
     int tmp1, tmp2;

     scanf("%d", &n);

     while (scanf("%d%d", &tmp1, &tmp2) == 2) {
           s[count] = tmp1;
           e[count] = tmp1 + tmp2;
           count++;
     }

     qsort(s, count, sizeof(int), int_cmp);
     qsort(e, count, sizeof(int), int_cmp);
}

void solve() {
     int sp, ep;
     int cnt;
     int ans;

     sp = ep = cnt = ans = 0;

     for (sp = 0; sp < count; sp++) {
         while (e[ep] < s[sp])
               {ep++; cnt--;}

         if (e[ep] == s[sp]) {
            while (e[ep] == s[sp])
               {ep++; cnt--;}

            if (cnt >= n)
               ans++;
         }

         cnt++;
     }

     printf("%d\n", ans);
}

int main() {
    read_data();
    solve();
    return 0;
}

