#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
//#define DEBUG
#define MAXN 200
#define TIME_LIMIT4 1.85
/*#define TIME_LIMIT3 1.35
#define TIME_LIMIT1 1.55
#define TIME_LIMIT2 1.85*/

typedef struct
  {
    short vr;
    short ou;
  } SNode;

short grid[MAXN][MAXN];
int n;
short set[MAXN];
int curr;
short opt[MAXN];
int br=0;
short grs[MAXN];
SNode nds[MAXN];


void Output();

int cmp(SNode *a,SNode *b)
  {
    return b->ou-a->ou;
  }

int cmp2(SNode *a,SNode *b)
  {
    return a->ou-b->ou;
  }


void Init()
  {
    int i,j;
    char ch;
#ifdef DEBUG
    freopen("bala.in","rt",stdin);
#endif
    scanf("%d",&n);
    for(i=1;i<n;i++)
      for(j=0;j<i;j++)
        {
          scanf("%c",&ch);
          while(!(ch=='0' || ch=='1'))
            scanf("%c",&ch);
          grid[i][j]=grid[j][i]=ch-'0';          
        }
    curr=n;
    for(i=0;i<n;i++) opt[i]=i;
  }

short Get(short vr)
  {
    short tmp;
    if(set[vr]==vr) return vr;
    tmp=Get(set[vr]);
    set[vr]=tmp;
    return tmp;
  }

int StavaJoin(short vr,short p)
  {
    int i;
    for(i=0;i<n;i++)
      if(set[i]==p && !grid[vr][i]) return 0;
    return 1;
  }

void Check()
  {
    if(br<curr)
      {
        memcpy(opt,set,sizeof(set));
        curr=br;
#ifdef DEBUG
        printf("Solution found : %d\n",curr);
        printf("Time %f sec.\n",(double)clock()/CLOCKS_PER_SEC);
#endif
      }
  }

/*void Find3(short vr_i,short p)
  {
    int i,j;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT3) return;
    if(br>=curr) return;
    set[nds[vr_i].vr]=Get(p);
    if(vr_i+1==n) { Check();return; }
    for(j=0;j<br;j++)
      if(grid[grs[j]][nds[vr_i+1].vr] && StavaJoin(nds[vr_i+1].vr,grs[j])) Find3(vr_i+1,grs[j]);
    set[nds[vr_i+1].vr]=grs[br++]=nds[vr_i+1].vr;
    Find3(vr_i+1,grs[br-1]);
    grs[br-1]=0;
    br--;
    set[nds[vr_i+1].vr]=-1;
    set[nds[vr_i].vr]=-1;
  }


void Greedy()
  {
    int i,j;
    // Init
    for(i=0;i<n;i++) set[i]=-1;
    for(i=0;i<n;i++) { nds[i].vr=i;nds[i].ou=0; }
    // Fill data
    for(i=1;i<n;i++)
      for(j=0;j<i;j++)
        if(grid[i][j]) { nds[i].ou++;nds[j].ou++; }
    // Sort data
    qsort(nds,n,sizeof(nds[0]),cmp);
    
    // Do the greedy
    br=0;
    set[nds[0].vr]=nds[0].vr;
    grs[0]=nds[0].vr;
    br++;
    Find3(0,grs[0]);
  }*/

void Find4(short vr_i,short p)
  {
    int i,j;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT4) Output();
    if(br>=curr) return;
    set[nds[vr_i].vr]=Get(p);
    if(vr_i+1==n) { Check();return; }
    for(j=0;j<br;j++)
      if(grid[grs[j]][nds[vr_i+1].vr] && StavaJoin(nds[vr_i+1].vr,grs[j])) Find4(vr_i+1,grs[j]);
    set[nds[vr_i+1].vr]=grs[br++]=nds[vr_i+1].vr;
    Find4(vr_i+1,grs[br-1]);
    grs[br-1]=0;
    br--;
    set[nds[vr_i+1].vr]=-1;
    set[nds[vr_i].vr]=-1;
  }



void Greedy2()
  {
    int i,j;
    // Init
    for(i=0;i<n;i++) set[i]=-1;
    for(i=0;i<n;i++) { nds[i].vr=i;nds[i].ou=0; }
    // Fill data
    for(i=1;i<n;i++)
      for(j=0;j<i;j++)
        if(grid[i][j]) { nds[i].ou++;nds[j].ou++; }
    // Sort data
    qsort(nds,n,sizeof(nds[0]),cmp2);
    
    // Do the greedy
    br=0;
    set[nds[0].vr]=grs[0]=nds[0].vr;
    br++;
    Find4(0,grs[0]);
  }


/*void Find(short vr,short p)
  {
    int i,j;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT1) return;
    if(br>=curr) return;
    set[vr]=Get(p);    
    if(vr+1==n) { Check();return; }

    // Try to join to some other group
    for(j=0;j<br;j++)
      if(grid[grs[j]][vr+1] && StavaJoin(vr+1,grs[j])) Find(vr+1,grs[j]);

    // Make new group
    set[vr+1]=vr+1;grs[br++]=vr+1;
    Find(vr+1,vr+1);
    grs[br-1]=0;
    br--;
    set[vr+1]=-1;
    set[vr]=-1;
  }

void Find2(short vr,short p)
  {
    int i,j;
    if((float)clock()/CLOCKS_PER_SEC>TIME_LIMIT2) Output();
    if(br>=curr) return;
    set[vr]=Get(p);    
    if(vr-1==-1) { Check();return; }
    
    // Try to join some group
    for(j=0;j<br;j++)
      if(grid[grs[j]][vr-1] && StavaJoin(vr-1,grs[j])) Find2(vr-1,grs[j]);
    // Make a new group
    set[vr-1]=grs[br++]=vr-1;
    Find2(vr-1,vr-1);
    grs[br-1]=0;
    br--;
    set[vr-1]=-1;
    set[vr]=-1;
  }


void Solve()
  {
    int i,j;
    // Initialize the sets
    set[0]=0;
    grs[0]=0;
    br++;
    Find(0,0);
  }

void Solve2()
  {
    int i,j;
    br=0;
    // Initialize the sets
    for(i=0;i<n;i++) set[i]=-1;
    set[n-1]=n-1;
    grs[0]=n-1;
    br++;
    Find2(n-1,n-1);
  }*/


void Output()
  {
    int i,j,tmp;
    printf("%d\n",curr);
    for(i=0;i<n;i++)
      if(opt[i]==i)
        {
          tmp=0;
          for(j=0;j<n;j++)
            if(opt[j]==i) tmp++;
          printf("%d\n",tmp);
          for(j=0;j<n && tmp>=1;j++)
            if(opt[j]==i)
              {
                printf((tmp!=1)?("%d "):("%d\n"),j+1);
                tmp--;
              }                
        }
#ifdef DEBUG
    printf("Time : %f sec.\n",(double)clock()/CLOCKS_PER_SEC);
#endif
    exit(0);
  }

int main()
  {
    clock();
    Init();
    Greedy2();
/*    Greedy();
    Solve();
    Solve2();*/
    Output();
    return 0;
  }
