#include <stdio.h>
#include <stdlib.h>
//#include <time.h>
#define MAXREC 1000050
#define ENTER 1
#define LEAVE 2

typedef struct
  {
    unsigned int sec;
    short kind;
  } SPoint;

SPoint pts[2*MAXREC];
int br=0;
int n,res=0;

int cmp(SPoint *a,SPoint *b)
  {
    if(a->sec==b->sec) return a->kind-b->kind;
    return a->sec-b->sec;
  }

void Init()
  {
//    freopen("club2.in","rt",stdin);
    scanf("%d",&n);
    for(br=0;;br+=2)
      {
        int res=scanf("%d%d",&pts[br].sec,&pts[br+1].sec);
        if(!(res>0)) break;
        pts[br].kind=ENTER;
        pts[br+1].sec+=pts[br].sec;
        pts[br+1].kind=LEAVE;
      }
  }

void Solve()
  {
    int i,l,r,inn,outt;
    int inside=0;
    qsort(pts,br,sizeof(pts[0]),cmp);
    for(i=0;i<br-1;i++)
      {
        l=i;
        r=i;
        inn=0;
        outt=0;
        while(pts[r].sec==pts[l].sec && r<br)
          {
            if(pts[r].kind==ENTER) inn++;
            else outt++;
            r++;
          }
        r--;
        if(!inn || !outt)
          {
            i=r;
            inside+=(inn-outt);
            continue;
          }
        if((inside-outt)>=n) res++;
        inside+=(inn-outt);
        i=r;
      }
  }

void Output()
  {
    printf("%d\n",res);
  }

int main()
  {
//    clock();
    Init();
    Solve();
    Output();
//    printf("Time : %f sec.\n",(double)clock()/CLOCKS_PER_SEC);
    return 0;
  }
