#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
//#include <time.h>

#define COME	1
#define LEAVE	0

typedef struct {
	unsigned int time;
	char status;
} SEvent;

int n;
SEvent e[2000004];
int ptr = 0;

int fcmp(const void *e1, const void *e2) {
	SEvent *s1, *s2;

	s1 = (SEvent *)e1;
	s2 = (SEvent *)e2;
	
	return s1->time - s2->time;
}

int main() {
	unsigned int s, t;
	int c, r, i;
	int cm, lv;
//	clock_t start;

//	start = clock();
	scanf("%i", &n);
	while (scanf("%i %i", &s, &t) == 2) {
		e[ptr].time = s;
		e[ptr++].status = COME;
		e[ptr].time = s + t;
		e[ptr++].status = LEAVE;
	}
	e[ptr++].time = 0xFFFFFFFF;
	
	qsort(e, ptr, sizeof(SEvent), fcmp);
	for (i = r = c = 0; i < ptr - 1; i++) {
		cm = lv = 0;
		while (1) {
			if (e[i].status == COME)
				cm++;
			else
				lv++;
			if (e[i + 1].time != e[i].time)
				break;
			i++;
		}

		if (cm && lv && (c - lv >= n))
			r++;
		c += cm - lv;
	}

	printf("%i\n", r);
//	printf("Time: %.3lf sec\n", (clock() - start)/(double)CLOCKS_PER_SEC);
	return 0;
}

