/* INCLUDES *****************************************************************/
   #include <iostream>
   //#include <cstdlib>
   //#include <values.h>

   //#include <vector>
   #include <queue>
   #include <algorithm>

   using namespace std;

/* CONSTANTS ****************************************************************/
   int const MAX = 1000004;

/* CLASSES ******************************************************************/

   class inter
   {
   public:
      inter() {}
      inter(long long _i, long long _s): i(_i), o(_i + _s) {}
      ~inter() {}

      bool operator < (inter const& _i) const
      {
         return i < _i.i;
      }

      long long i;
      long long o;
   };

   class comp
   {
   public:
      comp() {}
      ~comp() {}

      bool operator()(long long a, long long b) const
      {
         return a > b;
      }
   };

/* GLOBALS ******************************************************************/

   int n;
   int c_inters;
   inter inters[MAX];
   //vector<inter> inters;

   priority_queue<long long, vector<long long>, comp> pq;

   int b;

/* FUNCTIONS ****************************************************************/
/****************************************************************************/
/*   void done()
   {
      exit(0);
   }
/****************************************************************************/
   void init()
   {
      //inters.reserve(1000002);

      cin >> n;

      c_inters = 0;
      while (true)
      {
         long long i;
         long long s;

         cin >> i >> s;

         if (cin.fail()) break;

         //inters.push_back(inter(i, s));
         inters[c_inters] = inter(i, s);
         ++c_inters;
      }
   }
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
   void run()
   {
      b = 0;
      //sort(inters.begin(), inters.end());
      sort(inters, inters + c_inters);

      //pq.push(inters[0].o);
      //for (int i = 0; i < inters.size(); ++i)
      for (int i = 0; i < c_inters; ++i)
      {
         //inter it = inters[i];

         while (!pq.empty() && pq.top() < inters[i].i)
         {
            //long long top = pq.top();
            pq.pop();
         }

         if (!pq.empty() && pq.top() == inters[i].i)
         {
            while (!pq.empty() && pq.top() == inters[i].i)
            {
               //long long top = pq.top();
               pq.pop();
            }

            //long long pqsize = pq.size();
            if (pq.size() >= n) ++b;
         }

         pq.push(inters[i].o);
      }

      cout << b << endl;
   }
/****************************************************************************/
   int main()
   {
      init();
      run();
      //done();

      return 0;
   }
/****************************************************************************/

