#include <stdio.h>

#define MAXN            128

int parts[MAXN];
int max;
int k;

void read_data() {
     int last, tmp;

     while (scanf("%d", &tmp) == 1) {
           if (tmp < MAXN) parts[tmp]++;
           last = tmp;
     }

     if (last < MAXN) parts[last]--;
     k = last;
}

int find_next() {
    int i;
    int min;
    int sum;

    for (i = 2; i < max; i++) {
        if (parts[i])
           break;
    }

    if (!parts[i])
       return -1;

    min = i;
    parts[i]--;
    parts[1]++;
    parts[i - 1]++;

    for (i = max; i > 0; i--)
        if (parts[i]) {
           max = i;
           break;
        }

    sum = parts[1];
    parts[1] = 0;
    for (i = min - 1; i > 0; i--) {
        while (sum >= i) {
              parts[i]++;
              sum -= i;
        }
    }
}

void solve() {
     int i;

     for (i = MAXN - 1; i > 0; i--)
         if (parts[i]) {
            max = i;
            break;
         }
         
     for (i = 0; i < k; i++)
         if (find_next() == -1) {
            printf("%d\n", i);
            return;
         }

     printf("%d", max);
     parts[max]--;
     
     for (i = max; i > 0; i--) {
         while (parts[i]) {
               printf(" %d", i);
               parts[i]--;
         }
     }

     printf("\n");
}

int main() {
    read_data();
    solve();

    return 0;
}

