#include <ctime>
#include <iostream>

using namespace std;

bool a[200][200];
int N;
char buff[300];
int komp[200];
int k[200];
int h[200];
bool used[200];
bool first;

inline bool enemies(int l, int r) {
	for (int i = l; i <= r; i++) {
		for (int j = l; j <= r; j++) {
			if (!a[i][j]) return true;
		}
	}
	return false;
}

void div2(int l, int r) {
	if (enemies(l, r)) {
		div2(l, (l + r) / 2);
		div2((l + r) / 2 + 1, r);
	} else {
		cout << "[" << l << "; " << r << "]\n";
	}
}

void find1(int start) {
	int nn[200];
	int l[200];
	int lp = 0;
	for (int i = 0; i < N; i++) nn[i] = 0;
	for (int i = 0; i < N; i++) {
		if (a[start][i]) {
			l[lp++] = i;
		}
	}
	for (int i = 0; i < lp; i++) {
		for (int j = 0; j < N; j++) {
			if (a[start][j] > a[l[i]][j]) {
				a[start][l[i]] = false;
				a[l[i]][start] = false;
			}
		}
	}
}

void obh_k(int i, int k) {
	if (komp[i] >= 0) return;
	komp[i] = k;
	for (int j = 0; j < N; j++) {
		if (a[i][j]) obh_k(j, k);
	}
}

void find_komp() {
	for (int i = 0; i < N; i++) komp[i] = -1;
	for (int i = 0; i < N; i++) {
		obh_k(i, i);
	}
}

void obh_p(int i) {
	if (used[i]) return;
	used[i] = true;
	if (first) first = false;
	else cout << ' ';
	cout << (i + 1);
	for (int j = 0; j < N; j++) {
		if (a[i][j]) obh_p(j);
	}

}

void print_komp() {
	for (int i = 0; i < N; i++) {
		used[i] = false;
	}
	/*
	for (int i = 0; i < N; i++) {
		if (h[i] != 0) {
			cout << h[i] << '\n';
			first = true;
			obh_p(komp[i]);
			cout << '\n';
		}
	}
	*/
	for (int i = 0; i < N; i++) {
		if (komp[i] == i) {
			cout << h[komp[i]] << '\n';
			first = true;
			obh_p(i);
			cout << '\n';
		}
	}
}

int main() {
	//int FIN = clock() + 2 * CLOCKS_PER_SEC;
	cin >> N;
	for (int i = 1; i < N; i++) {
		cin.getline(buff, sizeof buff);
		for (int j = 0; j < i; j++) {
			a[i][j] = buff[j] != '0';
			a[j][i] = a[i][j];
		}
		a[i][i] = true;
	}
	//div2(0, N - 1);
	for (int i = 0; i < N; i++) {
		find1(i);
	}
	find_komp();
	int broj_k = 0;
	for (int i = 0; i < N; i++) {
		h[i] = 0;
	}
	for (int i = 0; i < N; i++) {
		h[komp[i]]++;
	}
	for (int i = 0; i < N; i++) {
		if (h[i] != 0) broj_k++;
	}
	cout << broj_k << '\n';
	print_komp();

	//cout << "kraj\n";
}
